Ruby - Bug #1749

Change in How $~ is Restored After String#sub/String#gsub with a Block
07/09/2009 09:52 AM - runpaint (Run Paint Run Run)

Status: Closed

Priority: Normal

Assignee:

Target version: 1.9.2

ruby -v: ruby 1.9.2dev (2009-07-08 trunk 23995) |Backport:
[i1686-linux]

Description

=begin

| wrote the following in [ruby-core:23699], but it seems to have been missed, so I'm filing it as a ticket. There are 3 RubySpec failures
relating to this issue, so it would be great to determine what's what. :-)

There's been a change between 1.8 and 1.9 in how $~ is restored after String#sub with a block. Upon leaving the #sub block, 1.8
restores $~ to what #sub set it to; 1.9 retains the value of $~ that was set inside the#sub block. The following code illustrates the
issue:

[/, "I"].each do |pattern|
old_md = nil
"hello".sub(pattern) do
old_md = $~
"ok".match(/./)

nogh

end

puts "S$~ == old_md? #{S$~ == old_md}" #
puts "$~.string == 'hello'? #{$~.string == 'hello'}" #

A
B

end

On 1.9.2 trunk, all conditionals are false; on 1.8.7/1.8.6 they're all true.

If you replace #sub with #gsub in the above example, the conditionals are still all true on 1.8. On 1.9 the $~.string conditionals (A) are
now true. The MatchData comparison (B) appears to succeed from the

#inspect output, but the objects have different #hash codes, so they don't compare for equality.

Is this change intentional, or evidence of a regression? :-)
=end

History

#1 - 07/16/2009 03:59 PM - yugui (Yuki Sonoda)
- Assignee set to akr (Akira Tanaka)

- Target version setto 1.9.2

=begin
=end

#2 - 07/16/2009 04:06 PM - akr (Akira Tanaka)

=begin
| think 1.9.2 behaviour is no problem.

String#sub matches a regexp just once.
There is no reason to set $~ at last.

String#gsub matches a regexp repeatedly until it doesn't match.
It set the last match after match failure for later use.

=end

06/13/2025 12



https://blade.ruby-lang.org/ruby-core/23699

#3 - 07/16/2009 04:13 PM - akr (Akira Tanaka)
- Assignee deleted (akr (Akira Tanaka))
=begin
=end
#4 - 08/02/2009 02:13 PM - runpaint (Run Paint Run Run)
=begin
| think 1.9.2 behaviour is no problem.

String#sub matches a regexp just once.
There is no reason to set $~ at last.

String#gsub matches a regexp repeatedly until it doesn't match.

It set the last match after match failure for later use.

| don't understand why the change was made, but if you're saying it's intentional then | suppose we can close this ticket. I'll update the specs to
indicate that this is a version-specific difference.
=end

#5 - 08/05/2009 12:40 PM - naruse (Yui NARUSE)
- Status changed from Open to Closed

=begin

=end
